<template>
  <div />
</template>

<script>
import * as d3 from "d3";

export default {
  name: "BarChart",

  data() {
    return {
      data: [
        {
          name: "10 años",
          value: 10,
        },
        {
          name: "7 años",
          value: 7,
        },
        {
          name: "6 años",
          value: 6,
        },
        {
          name: "5 años",
          value: 5,
        },
        {
          name: "2 años",
          value: 2,
        },
      ],
      labels: [],
      width: 100,
      height: 100,

      colorScale: ["#4A148C", "#DCC5F4"],
    };
  },

  mounted() {
    this.render();
  },

  methods: {
    render() {
      const margin = { top: 30, right: 0, bottom: 30, left: 40 };

      const yAxis = (g) =>
        g
          .attr("transform", `translate(${margin.left},0)`)
          .call(d3.axisLeft(y).ticks(null, this.data.format))
          .call((g) => g.select(".domain").remove())
          .call((g) =>
            g
              .append("text")
              .attr("x", -margin.left)
              .attr("y", 10)
              .attr("fill", "currentColor")
              .attr("text-anchor", "start")
              .text(this.data.y)
          );

      const xAxis = (g) =>
        g.attr("transform", `translate(0,${this.height - margin.bottom})`).call(
          d3
            .axisBottom(x)
            .tickFormat((i) => this.data[i].name)
            .tickSizeOuter(0)
        );

      const y = d3
        .scaleLinear()
        .domain([0, d3.max(this.data, (d) => d.value)])
        .nice()
        .range([this.height - margin.bottom, margin.top]);

      const x = d3
        .scaleBand()
        .domain(d3.range(this.data.length))
        .range([margin.left, this.width - margin.right])
        .padding(0.1);

      const svg = d3
        .select(this.$el)
        .append("svg")
        .attr("viewBox", [0, 0, this.width, this.height])
        .attr("font-size", 10)
        .attr("font-family", "sans-serif")
        .attr("text-anchor", "middle");

      svg
        .append("g")
        // .attr("fill", (d, i) => this.colorScale[i])
        .attr("fill", this.colorScale[0])
        .selectAll("rect")
        .data(this.data)
        .join("rect")
        .attr("x", (d, i) => x(i))
        .attr("y", (d) => y(d.value))
        .attr("height", (d) => y(0) - y(d.value))
        .attr("width", x.bandwidth());

      svg.append("g").call(xAxis);

      svg.append("g").call(yAxis);

      return svg.node();
    },
  },
};
</script>
